"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createService = void 0;
const testing_1 = require("@angular/core/testing");
const create_test_module_1 = require("./create-test-module");
const mock_statics_1 = require("./mock-statics");
const inject_root_providers_1 = require("./inject-root-providers");
const createService = (setup) => {
    (0, mock_statics_1.mockStatics)(setup);
    (0, inject_root_providers_1.injectRootProviders)(setup);
    testing_1.TestBed.configureTestingModule({ imports: [(0, create_test_module_1.createTestModule)(setup)] });
    return {
        instance: testing_1.TestBed.inject(setup.testComponentOrService),
        inject: testing_1.TestBed.inject.bind(testing_1.TestBed),
    };
};
exports.createService = createService;
//# sourceMappingURL=create-service.js.map