"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.mockComponent = void 0;
const reflect_1 = require("./reflect");
const core_1 = require("@angular/core");
const mock_of_directive_1 = require("./mock-of.directive");
const testing_1 = require("@angular/core/testing");
const mock_with_inputs_and_outputs_and_stubs_1 = require("./mock-with-inputs-and-outputs-and-stubs");
const forms_1 = require("@angular/forms");
const mockComponent = (component, config) => {
    const { selector, standalone, exportAs } = reflect_1.reflect.resolveComponent(component);
    let MockComponent = class MockComponent extends (0, mock_with_inputs_and_outputs_and_stubs_1.mockWithInputsOutputsAndStubs)(component, config === null || config === void 0 ? void 0 : config.stubs) {
    };
    MockComponent = __decorate([
        (0, mock_of_directive_1.MockOf)(component),
        (0, core_1.Component)({
            selector,
            template: '<ng-content></ng-content>',
            standalone,
            providers: [
                { provide: component, useExisting: (0, core_1.forwardRef)(() => MockComponent) },
                { provide: forms_1.NG_VALUE_ACCESSOR, useClass: forms_1.DefaultValueAccessor, multi: true },
            ],
            exportAs,
        })
    ], MockComponent);
    // Provide our mock in place of any other usage of 'thing'.
    // This makes `ViewChild` and `ContentChildren` selectors work!
    testing_1.TestBed.overrideComponent(MockComponent, {
        add: { providers: [{ provide: component, useExisting: (0, core_1.forwardRef)(() => MockComponent) }] },
    });
    return MockComponent;
};
exports.mockComponent = mockComponent;
//# sourceMappingURL=mock-component.js.map