import { AngularModule } from '../models/angular-module';
import { TestSetup } from '../models/test-setup';
import { CustomError } from '../models/custom-error';
export declare class InvalidModuleError extends CustomError {
    constructor(mod: any);
}
export type AnyNgModule = any[] | AngularModule;
export declare function mockModule<TModule extends AnyNgModule>(mod: TModule, setup: TestSetup<any>): TModule;
