import { ClassProvider, ExistingProvider, FactoryProvider, ModuleWithProviders, PipeTransform, Provider, TypeProvider, ValueProvider, Type, EnvironmentProviders } from '@angular/core';
export declare function isModuleWithProviders(thing: unknown): thing is ModuleWithProviders<any>;
export declare function isValueProvider(provider: Provider): provider is ValueProvider;
export declare function isExistingProvider(provider: Provider): provider is ExistingProvider;
export declare function isFactoryProvider(provider: Provider): provider is FactoryProvider;
export declare function isClassProvider(provider: Provider): provider is ClassProvider;
export declare function isTypeProvider(provider: Provider): provider is TypeProvider;
export declare function isPipeTransform(thing: unknown): thing is PipeTransform & Type<any>;
export declare const isClass: (thing: unknown) => thing is Type<any>;
/**
 * Angular explicitly obscured the EnvironmentProviders type that require hard-casting to unbox
 */
export declare const isEnvironmentProviders: (thing: Provider | EnvironmentProviders) => thing is EnvironmentProviders;
