"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.mockProviderClass = exports.MockOfProvider = void 0;
const mock_of_directive_1 = require("../tools/mock-of.directive");
const mock_with_stubs_1 = require("./mock-with-stubs");
class MockOfProvider extends mock_with_stubs_1.MockWithStubs {
}
exports.MockOfProvider = MockOfProvider;
const mockProviderClass = (provider, stubs) => {
    let MockProvider = class MockProvider extends MockOfProvider {
        constructor() {
            super(stubs);
        }
    };
    MockProvider = __decorate([
        (0, mock_of_directive_1.MockOf)(provider),
        __metadata("design:paramtypes", [])
    ], MockProvider);
    return MockProvider;
};
exports.mockProviderClass = mockProviderClass;
//# sourceMappingURL=mock-of-provider.js.map