import { EnvironmentProviders, NgModule, Provider, SchemaMetadata, Type } from '@angular/core';
import { AngularModule } from '../models/angular-module';
export interface NgModuleAnnotations extends NgModule {
    imports: (any[] | AngularModule)[];
    declarations: (any[] | Type<any>)[];
    providers: (Provider | EnvironmentProviders)[];
    exports: (Type<any> | any[])[];
    schemas: SchemaMetadata[] | any[];
}
export declare function getNgModuleAnnotations(ngModule: Type<any>): NgModuleAnnotations;
